<?php

function separe_scripts($os, $name)
{
    if ($os == "windows") {
        return [
            "\r\n:: script $name ::\r\n"
        ];
    } else {
        return [
            "\n# script $name #\n"
        ];
    }
}

function once_script($path, $app, $action, $local, $os, &$scripts)
{
    if ($action == "startup") {
        if ($local) {
            $local = ".local";
            $path = "/etc/sambaedu/applications/";
        } else {
            $local = "";
            $path = "/usr/share/sambaedu/applications/";
        }
        $filename = $path . $app . "/" . $action . "-once." . $os;
        if (file_exists($filename)) {
            $md5 = md5_file($filename);
            if ($os == "linux") {
                $scripts[$app . "-once" . $local] = [
                    "[ -f \"/etc/sambaedu/applications/$app-once-md5\" ] && local_md5=\$(cat /etc/sambaedu/applications/$app-once-md5)\n",
                    "if [ \"\${local_md5}\" != \"$md5\" ] ; then\n"
                ];
                $scripts[$app . "-once" . $local] = array_merge($scripts[$app . "-once" . $local], file($filename));
                $scripts[$app . "-once" . $local] = array_merge($scripts[$app . "-once" . $local], [
                    "echo \"" . $md5 . "\">\"/etc/sambaedu/applications/$app-once-md5\"\n",
                    "fi\n"
                ]);
            } else {
                $scripts[$app . "-once" . $local] = [
                    "if exist  \"%windir%\\$app-once.md5\" (for /F \"usebackq delims=\"  %%A in  (\"%windir%\\$app-once.md5\") do (set \"local_md5=%%A\"))\r\n",
                    "if [%local_md5%] NEQ [$md5] (\r\n",
                ];
                $liste = array();
                foreach (file($filename) as $ligne) {
                    $liste[] = $ligne . "\r\n";
                }
                $scripts[$app . "-once" . $local] = array_merge($scripts[$app . "-once" . $local], $liste);
                $scripts[$app . "-once" . $local] = array_merge($scripts[$app . "-once" . $local], [
                    "echo " . $md5 . ">%windir%\\$app-once.md5\r\n)\r\n"
                ]);
            }
        }
    }
}

function gen_scripts($local, $action, $list, $liste_applications, $os, &$scripts, &$scripts_server, &$packages, $application = "")
{
    if ($local) {
        $path = "/etc/sambaedu/applications/";
        $l = ".local";
    } else {
        $path = "/usr/share/sambaedu/applications/";
        $l = "";
    }
    if (empty($application)) {
        $apps = scandir($path);
    } else {
        $apps = [
            $application
        ];
    }
    foreach ($apps as $app) {
        if (file_exists($path . $app . "/" . $action . "." . $os) && $action != "wpkg") {
            $scripts[$app . $l] = file($path . $app . "/" . $action . "." . $os);
        }
        once_script($path, $app, $action, true, $os, $scripts);
        foreach ($list as $name) {
            if (file_exists($path . $app . "/" . $action . "@" . $name . "." . $os)) {
                $scripts[$app . "@" . $name . $l] = file($path . $app . "/" . $action . "@" . $name . "." . $os);
            }
        }
        // scripts à exécuter côté serveur (utilisateur root!)
        if (file_exists($path . $app . "/" . $action . "-server." . $os)) {
            $scripts_server[$app . $l] = file($path . $app . "/" . $action . "-server." . $os);
        }
        foreach ($list as $name) {
            if (file_exists($path . $app . "/" . $action . "-server@" . $name . "." . $os)) {
                $scripts_server[$app . "@" . $name . $l] = file($path . $app . "/" . $action . "-server@" . $name . "." . $os);
            }
        }
        // scripts conditionnés au paquet wpkg, executés uniquement si l'application est activee pour le parc
        if ($action == "wpkg" && in_array($app, $liste_applications) && file_exists($path . $app . "/wpkg." . $os)) {
            $scripts[$app . ".wpkg" . $l] = file($path . $app . "/wpkg." . $os);
        }
        if (in_array($app, $liste_applications) && file_exists($path . $app . "/" . $action . "-wpkg." . $os)) {
            $scripts[$app . $action . "wpkg" . $l] = file($path . $app . "/" . $action . "-wpkg." . $os);
        }
        // liste des packages a installer
        if (file_exists($path . $app . "/packages.list")) {
            $packages .= implode(" ", array_map('rtrim', file($path . $app . "/packages.list"))) . " ";
        }
        foreach ($list as $name) {
            if (file_exists($path . $app . "/packages@" . $name . ".list")) {
                $packages .= implode(" ", array_map('rtrim', file($path . $app . "/packages@" . $name . ".list"))) . " ";
            }
        }
    }
}

function local_admin($config, $user, $machine, $action, $os = "windows")
{
    $script = "";
    if ($os == "windows") {
        if (preg_match("/^" . $machine . "/i", $user)) {
            $script .= ":: on doit boucler pour attendre que l'utilisateur soit bien connecte\r
:test\r
if not [%userlogin%]==[] (goto dl)\r
for /f \"tokens=2 delims=\\ \" %%a in ('query session ^| findstr /c:\"Acti\"') do set userlogin=%%a\r
ping -n 1 localhost\r
goto test\r
:dl\r
curl.exe -o \"%TEMP%\\applications-" . $action . "-%userlogin%.cmd\" -F \"action=" . $action . "\" -F \"machine=%computername%\" -F \"user=%userlogin%\" \"http://" . $config['se4fs_name'] . "/gpo/applications.php\">NUL\r
if exist \"%TEMP%\\applications-" . $action . "-%userlogin%.cmd\" (call \"%TEMP%\\applications-" . $action . "-%userlogin%.cmd\")\r
";
        } else {
            $script .= "set userlogin=" . $user . "\r\n";
            if (get_local_admin_right($config, $user) != 0) {
                if ($action == "logon-system") {
                    if (have_right($config, "computer_is_admin", $user) || have_delegation($config, $machine, "manage", $user)) {
                        $script .= "net localgroup administrateurs " . $config['samba_domain'] . "\\" . $user . " /add\r\n";
                        $script .= "set admin=1\r\n";
                    }
                } else {
                    $script .= "net localgroup administrateurs " . $config['samba_domain'] . "\\" . $user . " /delete\r\n";
                }
            }
        }
    } else {
        if (get_local_admin_right($config, $user) != 0) {
            $u = strtr($user, ".", "_");
            if ($action == "logon-system") {
                if (have_right($config, "computer_is_admin", $user) || have_delegation($config, $machine, "manage", $user)) {
                    $script .= "echo \"" . $user . " ALL=(ALL:ALL) ALL \" > /etc/sudoers.d/$u\n";
                    $script .= "chmod 0440 /etc/sudoers.d/$u\n";
                }
            } else {
                $script .= "[ -f /etc/sudoers.d/$u ] && rm -f /etc/sudoers.d/$u\n";
            }
        }
    }
    return $script;
}

function get_app_scripts_info($config, $user, $machine, $action, $os, $id = "")
{
    if ($user == "Debian-gdm" || (preg_match("/^" . $machine . "/i", $user) || $user == "root") && $action != "startup" && $action != "shutdown") {
        // pas de script pour les utilisateurs ci-dessus au logon/logoff
        $id = false;
    } else {
        if (empty($id)) {
            $id = session_id();
        }
        if (! apcu_fetch("apps." . $id)) {
            $userl = $machinel = [];
            $admin = 0;
            // ajout de la gestion des parcs/groupes/wpkg
            // $machine = preg_replace("/^l-/", "", $machine);
            if (! empty($machine)) {
                $machinel = search_machine($config, $machine, true);
            } else {
                $machinel = [];
            }
            if (! empty($user)) {
                $userl = search_user($config, $user);
                exec("/usr/share/sambaedu/shares/share.avail/mkhome.sh " . $user);
            } else {
                $cnx_user = get_machine_status($config, $machinel['cn']);
                if (! empty($cnx_user['user'][0]['name'])) {
                    $userl = search_user($config, $cnx_user['user'][0]['name']);
                }
            }
            $user = $userl['cn'] ?? $user;
            $machine = $machinel['cn'] ?? $machine;
            $parcs = [];
            if (! empty($machinel['dn'])) {
                $salle = ldap_dn2cn(ldap_dn2oudn($machinel['dn']));
                // $parcs[] = $machine['cn'];
                if (isset($machinel['memberof'])) {
                    foreach ($machinel['memberof'] as $parc) {
                        $parcs[] = ldap_dn2cn($parc);
                    }
                }
            } else {
                $salle = "";
            }
            $groups = [];
            $list_u = $list_m = [];
            if (isset($userl['cn'])) {
                if (get_local_admin_right($config, $userl['cn']) > 0 && (have_right($config, "computer_is_admin", $userl['cn']) || have_delegation($config, $machine, "manage", $userl['cn']))) {
                    $admin = 1;
                }
                foreach ($userl['memberof'] as $group) {
                    $groups[] = ldap_dn2cn($group);
                }
                $list_u = array_unique(array_merge([
                    $userl['cn']
                ], $groups));
            }
            $list_m = array_unique(array_merge([
                $machinel['cn']
            ], [
                $salle
            ], $parcs));
            $list = array_unique(array_merge($list_u, $list_m));
            $liste_applications = [];
            if (! empty($action) && ! empty($os)) {

                if (file_exists("../includes/wpkg_lib.php")) {
                    require "wpkg_lib.php";
                    require "wpkg_libsql.php";
                    $liste_applications = array_map('strtolower', array_column(array_column(info_poste_applications($config, $machinel['cn']), "info_app"), "id_nom_app"));
                }
            }
            apcu_store("apps." . $id, [
                'user' => $userl,
                'salle' => $salle,
                'machine' => $machinel,
                'list' => $list,
                'list_u' => $list_u,
                'list_m' => $list_m,
                'liste_applications' => $liste_applications,
                'admin' => $admin,
                'os' => $os
            ], 300);
        }
    }
    return $id;
}
?>
