<?php

function set_debug($config)
{
    $debug = $config['debug'] ?? 0;
    if (is_dir("/etc/php/7.4")) {
        $php_version = "7.4";
    } elseif (is_dir("/etc/php/7.3")) {
        $php_version = "7.3";
    } else {
        $php_version = "7.0";
    }
    $php_conf_path = "/etc/php/" . $php_version;
    $xdebug = parse_ini_file($php_conf_path . "/mods-available/xdebug.ini");
    switch ($debug) {
        case 1:
            $xdebug['xdebug.mode'] = "trace";
            $xdebug['xdebug.show_error_trace'] = 1;
            $xdebug['xdebug.collect_params'] = 3;
            exec("echo 'php_flag[display_errors] = on' | sudo tee -a " . $php_conf_path . "/fpm/pool.d/sambaedu.conf");
            set_param($config, "debug", "1");
            echo "Mode debug activé !<br>";
            break;
        case 2:
            $xdebug['xdebug.mode'] = "profile";
            $xdebug['xdebug.show_error_trace'] = 0;
            $xdebug['xdebug.collect_params'] = 0;
            $xdebug['xdebug.log'] = "/tmp";
            $xdebug['xdebug.profiler_append'] = 0;
            $xdebug['xdebug.profiler_output_name'] = "cachegrind.out%R";
            set_param($config, "debug", "2");
            echo "Mode profilage activé !<br>";
            break;
        default:
            $xdebug['xdebug.mode'] = "off";
            $xdebug['xdebug.show_error_trace'] = 0;
            $xdebug['xdebug.collect_params'] = 0;
            exec("sudo sed -i '/^php_flag\[display_errors\] = on$/d' " . $php_conf_path . "/fpm/pool.d/sambaedu.conf");
            set_param($config, "debug", "0");
            echo "Mode debug désactivé !<br>";
    }
    $lignes =[];
    foreach ($xdebug as $key => $value) {
        $lignes[] = "    " . $key . " = " . $value;
    }
    system("sudo chown www-admin " . $php_conf_path . "/mods-available/xdebug.ini");
    file_put_contents($php_conf_path . "/mods-available/xdebug.ini", implode(PHP_EOL, $lignes) . PHP_EOL);
    system("sudo chown root " . $php_conf_path . "/mods-available/xdebug.ini");
    system("sudo -b bash -c \"sleep 10 && systemctl restart php" . $php_version . "-fpm.service\"");
}
?>