<?php
/**
 ** Interface Utilisateur
 **/
require_once 'config.inc.php';
require_once 'partages.inc.php';
require_once 'samba.inc.php';
require_once 'functions.inc.php';
require_once 'ldap.inc.php';
require_once 'logs.inc.php';
require_once 'ihm.inc.php';
require_once 'ent.inc.php';
require_once 'cloud.inc.php';
require_once 'user.interface.inc.php';
require_once "../vendor/autoload.php";

$html = "";
$autolog = false;

if (! empty($_SESSION['login'])) {
    // session OK
    $html = html_user_interface($config);
} else {
    session_destroy();
    $login = $_POST['login'] ?? "";
    // recherche de l'utilisateur ayant ouvert la session
    if (empty($login)) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'] ?? $_SERVER['REMOTE_ADDR'];
        if ($machine = @search_machine($config, $ip, false)['cn']) {
            $users = @get_machine_status($config, $machine)['user'];
            if (isset($users) && count($users) == 1) {
                $login = $users[0]['name'];
                $autolog = true;
            }
        }
    }
    if (! empty($login) && ((! empty($_POST['password']) && user_valid_passwd($config, $login, $_POST['password'])) || $autolog)) {
        // password ok en direct ou autologin ok
        session_name("Sambaedu");
        @session_start([
            'cookie_lifetime' => 86400
        ]);
        $_SESSION['login'] = $login;
        $html = html_user_interface($config);
    } elseif (! empty($config['ent_auth']) && $config['ent_auth'] == 1 && @$config['ent_status'] == 1) {
        // auth sur l'ent
        header("Location: ../oauth2/login.php");
    } else {
        // auth directe
        $html = html_login_form();
    }
    // }
}
print $html;

?>